<template>
    <v-container fluid>
        <v-card max-width="1200px" class="ma-auto" color="primary" dark>
            <v-alert v-if="err != ''" dense text type="error">
                {{err}}
            </v-alert>
            <v-alert v-if="ok != ''" dense text type="success">
                {{success}}
            </v-alert>
            <v-card-title>{{floor.info.name}}</v-card-title>
            <v-card-subtitle>{{floor.info.id}} @ {{floor.info.timeZone}}</v-card-subtitle>
            <v-tabs v-model="tabs" centered grow background-color="primary">
                <v-tab>
                    FloorPlans
                </v-tab>
                <v-tab>
                    Rules
                </v-tab>
            </v-tabs>
            <v-tabs-items v-model="tabs">
                <v-tab-item class="pa-6">
                    <v-data-table
                            :headers="floorPlanHeaders" :items="floor.floorPlans" :items-per-page="20">
                        <template v-slot:item.timeStamp="{ item }">
                            {{ ParseDate(item.timeStamp)}}
                        </template>
                    </v-data-table>
                </v-tab-item>
                <v-tab-item class="pa-6">
                    <v-data-table
                            :headers="ruleHeaders" :items="rules" :items-per-page="20">
                        <template v-slot:item.rule.labels="{ item }">
                            <div>
                                <v-chip v-for="l in item.rule.labels">
                                    {{l}}
                                </v-chip>
                            </div>
                        </template>
                        <template v-slot:item.triggerType="{ item }">
                            {{ FormatTriggerType(item.triggerType)}}
                        </template>
                        <template v-slot:item.subscribedUsers="{ item }">
                            <IconActions v-if="!IsSubscribed(item.subscribedUsers)" icon="$vuetify.icons.subscribe"
                                         :action="()=> {Subscribe(item.id)}"
                                         tooltip="Subscribe to rule"/>
                            <IconActions v-else icon="$vuetify.icons.unsub" :action="()=> {UnSubscribe(item.id)}"
                                         tooltip="Unsubscribe from rule"/>
                        </template>
                    </v-data-table>
                    <v-dialog v-model="dialog" persistent max-width="600px" class="pa-4">
                        <template #activator="{ on: onD, attrs: attrD }">
                            <v-tooltip bottom>
                                <template #activator="{ on: onT, attrs: attrT }">
                                    <v-btn color="pink" dark absolute bottom right fab v-bind="{...attrD,...attrT}"
                                           v-on="{...onT,...onD}">
                                        <v-icon>mdi-plus</v-icon>
                                    </v-btn>
                                </template>
                                <span>Add Rule</span>
                            </v-tooltip>
                        </template>
                        <AddRuleToFloor :close-f="closeDialog" :create-f="init" :floor-id="floorId"/>
                    </v-dialog>
                </v-tab-item>

            </v-tabs-items>

        </v-card>
    </v-container>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component, Prop} from 'vue-property-decorator';
    import {Initializable} from "../../mixins/Initializable";
    import {FloorResponse} from "../../../../classLibrary/core/floorResponse";
    import {FloorFlyWeightResponse} from "../../../../classLibrary/core/floorFlyWeightResponse";
    import {MinimalFloorPlanResponse} from "../../../../classLibrary/core/minimalFloorPlanResponse";
    import {auth, coreApi, triggerType} from "../../init";
    import moment from "moment";
    import "moment-timezone";
    import {BStorage} from "../../../../classLibrary/Storage";
    import AddRuleToFloor from "../../components/AddRuleToFloor.vue";
    import {ActiveRuleResponse} from "../../../../classLibrary/core/activeRuleResponse";
    import {Validable} from "../../mixins/Validable";
    import {Mixins} from "vue-mixin-decorator";
    import IconLinks from "../../components/IconLinks.vue";
    import IconActions from "../../components/IconActions.vue";


    interface FloorInformationMixin extends Validable, Initializable {
    }

    @Component({
        components: {IconActions, IconLinks, AddRuleToFloor}
    })
    export default class FloorInformation extends Mixins<FloorInformationMixin>(Validable, Initializable) {
        @Prop() store!: BStorage;

        dialog = false;

        floorId: string = '';
        floor: FloorResponse = new FloorResponse(new FloorFlyWeightResponse('', '', ''), new MinimalFloorPlanResponse('', '', ''), []);

        rules: ActiveRuleResponse[] = [];

        tabs: any = null;
        ruleHeaders = [
            {
                text: 'Name',
                align: 'start',
                sortable: true,
                value: 'rule.name',
            },
            {
                text: 'Description',
                align: 'start',
                sortable: false,
                value: 'rule.description',
            },
            {
                text: 'Labels',
                align: 'start',
                sortable: false,
                value: 'rule.labels',
            },
            {
                text: 'Trigger Type',
                align: 'center',
                sortable: false,
                value: 'rule.triggerType'
            },
            {
                text: 'Name',
                align: 'start',
                sortable: true,
                value: 'rule.name',
            },
            {
                text: 'Actions',
                alight: 'center',
                sortable: false,
                value: 'subscribedUsers'
            }
        ]
        floorPlanHeaders = [
            {
                text: 'Version',
                align: 'start',
                sortable: true,
                value: 'name',
            },
            {
                text: 'ID',
                align: 'start',
                sortable: true,
                value: 'id',
            },
            {
                text: 'Time',
                align: 'start',
                sortable: true,
                value: 'timeStamp',
            },
        ]

        ParseDate(i: string): string {
            return moment(i).tz(this.store.value.tz).calendar()
        }

        FormatTriggerType(v: string): string {
            return triggerType.Find(x => x.value === v)?.name ?? "";
        }


        closeDialog() {
            this.dialog = false;
        }


        async UnSubscribe(id: string) {
            const uid = auth.UserId;
            console.log(id);
            const r = await coreApi.QPost(`ActiveRule/unsubscribe?userId=${uid}&id=${id}`);
            if (r == "") {
                await this.init();
            } else {
                this.err = r;
            }
        }

        async Subscribe(id: string) {
            const uid = auth.UserId;
            console.log(id);
            const r = await coreApi.QPost(`ActiveRule/subscribe?userId=${uid}&id=${id}`);
            if (r == "") {
                await this.init();
            } else {
                this.err = r;
            }
        }

        IsSubscribed(current: string[]): boolean {
            const id = auth.UserId;
            return current.Has(id);
        }

        async init() {
            this.err = '';
            this.floorId = this.$route.params.floorId as any;
            const floorResult = await coreApi.Get<FloorResponse>(`Floor/${this.floorId}`)
            if (floorResult.success) {
                this.floor = floorResult.Ok!;
            } else {
                await this.$router.push('not-found')
            }
            const ruleResult = await coreApi.Get<ActiveRuleResponse[]>(`ActiveRule/floor/${this.floorId}`);
            if (ruleResult.success) {
                this.rules = ruleResult.Ok!;
            } else {
                this.err = ruleResult.error!;
            }
        }


    }
</script>
